searchNodes=[{"doc":"EarmarkAstDsl is a toolset to generate EarmarkParser conformant AST Nodes version 1.4.6 and on, which is the always return quadruples version. Its main purpose is to remove boilerplate code from Earmark and EarmarkParser tests. Documentation for EarmarkAstDsl . tag The most general helper is the tag function: iex(1)&gt; tag ( &quot;div&quot; , &quot;Some content&quot; ) { &quot;div&quot; , [ ] , [ &quot;Some content&quot; ] , %{ } } Content and attributes can be provided as arrays, ... iex(2)&gt; tag ( &quot;p&quot; , ~w[Hello World] , class : &quot;hidden&quot; ) { &quot;p&quot; , [ { &quot;class&quot; , &quot;hidden&quot; } ] , [ &quot;Hello&quot; , &quot;World&quot; ] , %{ } } ... or maps: iex(3)&gt; tag ( &quot;p&quot; , ~w[Hello World] , %{ class : &quot;hidden&quot; } ) { &quot;p&quot; , [ { &quot;class&quot; , &quot;hidden&quot; } ] , [ &quot;Hello&quot; , &quot;World&quot; ] , %{ } } Annotations (as implemented in EarmarkParser &gt;= v1.4.16) In order to not overload tha API for tag/2 , tag/3 and tag/4 we offer the general tag_annotated function iex(4)&gt; tag_annotated ( &quot;header&quot; , &quot;content&quot; , &quot;annotation&quot; ) { &quot;header&quot; , [ ] , [ &quot;content&quot; ] , %{ annotation : &quot;annotation&quot; } } in this case atts come last iex(5)&gt; tag_annotated ( &quot;header&quot; , &quot;content&quot; , &quot;annotation&quot; , class : &quot;two&quot; ) { &quot;header&quot; , [ { &quot;class&quot; , &quot;two&quot; } ] , [ &quot;content&quot; ] , %{ annotation : &quot;annotation&quot; } } Shortcuts for common tags ( a , div , li , p ) iex(6)&gt; a ( &quot;hello&quot; , href : &quot;mylink&quot; ) { &quot;a&quot; , [ { &quot;href&quot; , &quot;mylink&quot; } ] , [ &quot;hello&quot; ] , %{ } } iex(7)&gt; p ( &quot;A para&quot; ) { &quot;p&quot; , [ ] , [ &quot;A para&quot; ] , %{ } } iex(8)&gt; div ( tag ( &quot;span&quot; , &quot;content&quot; ) ) { &quot;div&quot; , [ ] , [ { &quot;span&quot; , [ ] , [ &quot;content&quot; ] , %{ } } ] , %{ } } iex(9)&gt; li ( p ( &quot;hello&quot; ) ) { &quot;li&quot; , [ ] , [ { &quot;p&quot; , [ ] , [ &quot;hello&quot; ] , %{ } } ] , %{ } } Pluriel form for paragraphs tags iex(10)&gt; tags ( &quot;p&quot; , ~W[a b c] ) [ { &quot;p&quot; , [ ] , [ &quot;a&quot; ] , %{ } } , { &quot;p&quot; , [ ] , [ &quot;b&quot; ] , %{ } } , { &quot;p&quot; , [ ] , [ &quot;c&quot; ] , %{ } } ] More helpers, which are less common are described on their functiondocs","ref":"EarmarkAstDsl.html","title":"EarmarkAstDsl","type":"module"},{"doc":"","ref":"EarmarkAstDsl.html#a/2","title":"EarmarkAstDsl.a/2","type":"function"},{"doc":"A convenient shortcut for the often occurring &lt;blockquoye&gt;&lt;p&gt; tag chain iex(11)&gt; blockquote ( &quot;Importante!&quot; ) { &quot;blockquote&quot; , [ ] , [ { &quot;p&quot; , [ ] , [ &quot;Importante!&quot; ] , %{ } } ] , %{ } } All passed in attributes go to the blockquote tag iex(12)&gt; blockquote ( &quot;Très important&quot; , lang : &quot;fr&quot; ) { &quot;blockquote&quot; , [ { &quot;lang&quot; , &quot;fr&quot; } ] , [ { &quot;p&quot; , [ ] , [ &quot;Très important&quot; ] , %{ } } ] , %{ } }","ref":"EarmarkAstDsl.html#blockquote/2","title":"EarmarkAstDsl.blockquote/2","type":"function"},{"doc":"","ref":"EarmarkAstDsl.html#div/2","title":"EarmarkAstDsl.div/2","type":"function"},{"doc":"iex(13)&gt; div_annotated ( &quot;content&quot; , &quot;special&quot; , class : &quot;special_class&quot; ) { &quot;div&quot; , [ { &quot;class&quot; , &quot;special_class&quot; } ] , [ &quot;content&quot; ] , %{ annotation : &quot;special&quot; } } iex(14)&gt; div_annotated ( &quot;content&quot; , &quot;special&quot; ) { &quot;div&quot; , [ ] , [ &quot;content&quot; ] , %{ annotation : &quot;special&quot; } }","ref":"EarmarkAstDsl.html#div_annotated/3","title":"EarmarkAstDsl.div_annotated/3","type":"function"},{"doc":"","ref":"EarmarkAstDsl.html#li/2","title":"EarmarkAstDsl.li/2","type":"function"},{"doc":"Creates a list of li itmes iex(15)&gt; lis ( ~W[alpha beta gamma] ) [ { &quot;li&quot; , [ ] , [ &quot;alpha&quot; ] , %{ } } , { &quot;li&quot; , [ ] , [ &quot;beta&quot; ] , %{ } } , { &quot;li&quot; , [ ] , [ &quot;gamma&quot; ] , %{ } } ] Which can typically be used in, well, a list iex(16)&gt; tag ( &quot;ol&quot; , lis ( [ &quot;a&quot; , p ( &quot;b&quot; ) ] ) ) { &quot;ol&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;a&quot; ] , %{ } } , { &quot;li&quot; , [ ] , [ { &quot;p&quot; , [ ] , [ &quot;b&quot; ] , %{ } } ] , %{ } } ] , %{ } }","ref":"EarmarkAstDsl.html#lis/1","title":"EarmarkAstDsl.lis/1","type":"function"},{"doc":"The ol helper is different in respect to other helpers as it wraps content elements into li tags if necessary iex(17)&gt; ol ( [ &quot;hello&quot; , &quot;world&quot; ] ) { &quot;ol&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;hello&quot; ] , %{ } } , { &quot;li&quot; , [ ] , [ &quot;world&quot; ] , %{ } } ] , %{ } } but as mentioned only if necessary so that we can refine li elements with attributes or meta if we want iex(18)&gt; ol ( [ &quot;hello&quot; , li ( &quot;world&quot; , class : &quot;global&quot; ) ] ) { &quot;ol&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;hello&quot; ] , %{ } } , { &quot;li&quot; , [ { &quot;class&quot; , &quot;global&quot; } ] , [ &quot;world&quot; ] , %{ } } ] , %{ } } if there is only one li no list needs to be passed in iex(19)&gt; ol ( &quot;hello&quot; ) { &quot;ol&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;hello&quot; ] , %{ } } ] , %{ } }","ref":"EarmarkAstDsl.html#ol/2","title":"EarmarkAstDsl.ol/2","type":"function"},{"doc":"","ref":"EarmarkAstDsl.html#p/2","title":"EarmarkAstDsl.p/2","type":"function"},{"doc":"iex(20)&gt; p_annotated ( &quot;text&quot; , &quot;annotation&quot; ) { &quot;p&quot; , [ ] , [ &quot;text&quot; ] , %{ annotation : &quot;annotation&quot; } }","ref":"EarmarkAstDsl.html#p_annotated/3","title":"EarmarkAstDsl.p_annotated/3","type":"function"},{"doc":"A convenient shortcut for the often occurring &lt;pre&gt;&lt;code&gt; tag chain iex(21)&gt; pre_code ( &quot;hello&quot; ) { &quot;pre&quot; , [ ] , [ { &quot;code&quot; , [ ] , [ &quot;hello&quot; ] , %{ } } ] , %{ } }","ref":"EarmarkAstDsl.html#pre_code/2","title":"EarmarkAstDsl.pre_code/2","type":"function"},{"doc":"The annotation adding helper iex(22)&gt; pre_code_annotated ( &quot;code&quot; , &quot;@@lang=elixir&quot; ) { &quot;pre&quot; , [ ] , [ { &quot;code&quot; , [ ] , [ &quot;code&quot; ] , %{ annotation : &quot;@@lang=elixir&quot; } } ] , %{ } }","ref":"EarmarkAstDsl.html#pre_code_annotated/3","title":"EarmarkAstDsl.pre_code_annotated/3","type":"function"},{"doc":"Tables Tables are probably the raison d'être ot this little lib, as their ast is quite verbose, as we will see here: iex(26)&gt; table ( &quot;one cell only&quot; ) # and look at the output { &quot;table&quot; , [ ] , [ { &quot;tbody&quot; , [ ] , [ { &quot;tr&quot; , [ ] , [ { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;one cell only&quot; ] , %{ } } ] , %{ } } ] , %{ } } ] , %{ } } Now if we want a header and have some more data: iex(27)&gt; table ( [ ~w[1-1 1-2] , ~w[2-1 2-2] ] , head : ~w[left right] ) # This is quite verbose! { &quot;table&quot; , [ ] , [ { &quot;thead&quot; , [ ] , [ { &quot;tr&quot; , [ ] , [ { &quot;th&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;left&quot; ] , %{ } } , { &quot;th&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;right&quot; ] , %{ } } , ] , %{ } } ] , %{ } } , { &quot;tbody&quot; , [ ] , [ { &quot;tr&quot; , [ ] , [ { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;1-1&quot; ] , %{ } } , { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;1-2&quot; ] , %{ } } , ] , %{ } } , { &quot;tr&quot; , [ ] , [ { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;2-1&quot; ] , %{ } } , { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;2-2&quot; ] , %{ } } , ] , %{ } } ] , %{ } } ] , %{ } } And tables can easily be aligned differently in Markdown, which makes some style helpers very useful iex(28)&gt; table ( [ ~w[1-1 1-2] , ~w[2-1 2-2] ] , ...(28)&gt; head : ~w[alpha beta] , ...(28)&gt; text_aligns : ~w[right center] ) { &quot;table&quot; , [ ] , [ { &quot;thead&quot; , [ ] , [ { &quot;tr&quot; , [ ] , [ { &quot;th&quot; , [ { &quot;style&quot; , &quot;text-align: right;&quot; } ] , [ &quot;alpha&quot; ] , %{ } } , { &quot;th&quot; , [ { &quot;style&quot; , &quot;text-align: center;&quot; } ] , [ &quot;beta&quot; ] , %{ } } , ] , %{ } } ] , %{ } } , { &quot;tbody&quot; , [ ] , [ { &quot;tr&quot; , [ ] , [ { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: right;&quot; } ] , [ &quot;1-1&quot; ] , %{ } } , { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: center;&quot; } ] , [ &quot;1-2&quot; ] , %{ } } , ] , %{ } } , { &quot;tr&quot; , [ ] , [ { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: right;&quot; } ] , [ &quot;2-1&quot; ] , %{ } } , { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: center;&quot; } ] , [ &quot;2-2&quot; ] , %{ } } , ] , %{ } } ] , %{ } } ] , %{ } } Some leeway is given for the determination of the number of columns, bear in mind that Markdown only supports regularly shaped tables with a fixed number of columns. Problems might arise when we have a table like the following | alpha | | beta * gamma * | where the first cell contains one element, but the second two, we can hint that we only want one by grouping into tuples iex(29)&gt; table ( [ &quot;alpha&quot; , { &quot;beta&quot; , tag ( &quot;em&quot; , &quot;gamma&quot; ) } ] ) { &quot;table&quot; , [ ] , [ { &quot;tbody&quot; , [ ] , [ { &quot;tr&quot; , [ ] , [ { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;alpha&quot; ] , %{ } } , ] , %{ } } , { &quot;tr&quot; , [ ] , [ { &quot;td&quot; , [ { &quot;style&quot; , &quot;text-align: left;&quot; } ] , [ &quot;beta&quot; , { &quot;em&quot; , [ ] , [ &quot;gamma&quot; ] , %{ } } ] , %{ } } ] , %{ } } ] , %{ } } ] , %{ } }","ref":"EarmarkAstDsl.html#table/2","title":"EarmarkAstDsl.table/2","type":"function"},{"doc":"This is the base helper which emits a tag with its content, attributes and metadata can be added at the user's convenience iex(30)&gt; tag ( &quot;div&quot; ) { &quot;div&quot; , [ ] , [ ] , %{ } } With content, iex(31)&gt; tag ( &quot;span&quot; , &quot;hello&quot; ) { &quot;span&quot; , [ ] , [ &quot;hello&quot; ] , %{ } } ... and attributes, iex(32)&gt; tag ( &quot;code&quot; , &quot;let it(:be_light)&quot; , [ class : &quot;inline&quot; ] ) { &quot;code&quot; , [ { &quot;class&quot; , &quot;inline&quot; } ] , [ &quot;let it(:be_light)&quot; ] , %{ } } ... and metadata iex(33)&gt; tag ( &quot;div&quot; , &quot;content&quot; , [ ] , %{ verbatim : true } ) { &quot;div&quot; , [ ] , [ &quot;content&quot; ] , %{ verbatim : true } }","ref":"EarmarkAstDsl.html#tag/4","title":"EarmarkAstDsl.tag/4","type":"function"},{"doc":"A convience function for easy addition of an annotation to the meta map","ref":"EarmarkAstDsl.html#tag_annotated/4","title":"EarmarkAstDsl.tag_annotated/4","type":"function"},{"doc":"","ref":"EarmarkAstDsl.html#tags/4","title":"EarmarkAstDsl.tags/4","type":"function"},{"doc":"The ul helper is different in respect to other helpers as it wraps content elements into li tags if necessary iex(23)&gt; ul ( [ &quot;hello&quot; , &quot;world&quot; ] ) { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;hello&quot; ] , %{ } } , { &quot;li&quot; , [ ] , [ &quot;world&quot; ] , %{ } } ] , %{ } } but as mentioned only if necessary so that we can refine li elements with attributes or meta if we want iex(24)&gt; ul ( [ &quot;hello&quot; , li ( &quot;world&quot; , class : &quot;global&quot; ) ] ) { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;hello&quot; ] , %{ } } , { &quot;li&quot; , [ { &quot;class&quot; , &quot;global&quot; } ] , [ &quot;world&quot; ] , %{ } } ] , %{ } } if there is only one li no list needs to be passed in iex(25)&gt; ul ( &quot;hello&quot; ) { &quot;ul&quot; , [ ] , [ { &quot;li&quot; , [ ] , [ &quot;hello&quot; ] , %{ } } ] , %{ } }","ref":"EarmarkAstDsl.html#ul/2","title":"EarmarkAstDsl.ul/2","type":"function"},{"doc":"Void tags are just convenient shortcats for calls to tag with the second argument nil or [] One cannot pass metadata to a void_tag call iex(34)&gt; void_tag ( &quot;hr&quot; ) { &quot;hr&quot; , [ ] , [ ] , %{ } } iex(35)&gt; void_tag ( &quot;hr&quot; , class : &quot;thin&quot; ) { &quot;hr&quot; , [ { &quot;class&quot; , &quot;thin&quot; } ] , [ ] , %{ } }","ref":"EarmarkAstDsl.html#void_tag/2","title":"EarmarkAstDsl.void_tag/2","type":"function"},{"doc":"Again the annotated version is available iex(36)&gt; void_tag_annotated ( &quot;br&quot; , &quot;// break&quot; ) { &quot;br&quot; , [ ] , [ ] , %{ annotation : &quot;// break&quot; } } iex(37)&gt; void_tag_annotated ( &quot;wbr&quot; , &quot;// for printer&quot; , class : &quot;nine&quot; ) { &quot;wbr&quot; , [ { &quot;class&quot; , &quot;nine&quot; } ] , [ ] , %{ annotation : &quot;// for printer&quot; } }","ref":"EarmarkAstDsl.html#void_tag_annotated/3","title":"EarmarkAstDsl.void_tag_annotated/3","type":"function"},{"doc":"vtags are tags from verbatim html iex(38)&gt; vtag ( &quot;div&quot; , &quot;hello&quot; ) { &quot;div&quot; , [ ] , [ &quot;hello&quot; ] , %{ verbatim : true } } Attributes can be provided, of course iex(39)&gt; vtag ( &quot;div&quot; , [ &quot;some&quot; , &quot;content&quot; ] , [ { &quot;data-lang&quot; , &quot;elixir&quot; } ] ) { &quot;div&quot; , [ { &quot;data-lang&quot; , &quot;elixir&quot; } ] , [ &quot;some&quot; , &quot;content&quot; ] , %{ verbatim : true } }","ref":"EarmarkAstDsl.html#vtag/3","title":"EarmarkAstDsl.vtag/3","type":"function"},{"doc":"Verbatim tags still can be annotated and therefore we have this helper iex(40)&gt; vtag_annotated ( &quot;i&quot; , &quot;emphasized&quot; , &quot;-- verbatim&quot; , printer : &quot;no&quot; ) { &quot;i&quot; , [ { &quot;printer&quot; , &quot;no&quot; } ] , [ &quot;emphasized&quot; ] , %{ annotation : &quot;-- verbatim&quot; , verbatim : true } }","ref":"EarmarkAstDsl.html#vtag_annotated/4","title":"EarmarkAstDsl.vtag_annotated/4","type":"function"},{"doc":"","ref":"EarmarkAstDsl.html#t:ast_node/0","title":"EarmarkAstDsl.ast_node/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:ast_t/0","title":"EarmarkAstDsl.ast_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:ast_ts/0","title":"EarmarkAstDsl.ast_ts/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:att_list/0","title":"EarmarkAstDsl.att_list/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:att_t/0","title":"EarmarkAstDsl.att_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:att_ts/0","title":"EarmarkAstDsl.att_ts/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:binaries/0","title":"EarmarkAstDsl.binaries/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:content_t/0","title":"EarmarkAstDsl.content_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:free_atts_t/0","title":"EarmarkAstDsl.free_atts_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:matrix_t/0","title":"EarmarkAstDsl.matrix_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:maybe/1","title":"EarmarkAstDsl.maybe/1","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:row_t/0","title":"EarmarkAstDsl.row_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:scalar_t/0","title":"EarmarkAstDsl.scalar_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:table_t/0","title":"EarmarkAstDsl.table_t/0","type":"type"},{"doc":"","ref":"EarmarkAstDsl.html#t:vector_t/0","title":"EarmarkAstDsl.vector_t/0","type":"type"}]